/*Mostra a led i piani prenotati (un led per piano)
si occupa di far contare il contatore di conseguenza
gestisce lo stop d'emergenza e lo stop ai piani*/
module control(clearContatore, clock, inButton0, inButton1, inButton2, inButton3, emergencySwitch, ledBus0, ledBus1, ledBus2, ledBus3, countEnable, countEnablePiano, upDown, qBus, emergencyLed, pianoBus, clearPiano);
input clock, inButton0, inButton1, inButton2, inButton3, emergencySwitch, qBus, pianoBus;
output clearContatore, upDown, countEnable, countEnablePiano, emergencyLed, ledBus0, ledBus1, ledBus2, ledBus3, clearPiano;
wire inButton0, inButton1, inButton2, inButton3, emergencySwitch;
wire [7:0] qBus;
wire [3:0] pianoBus;
reg[3:0] prenotati;
reg clearContatore, countEnable, upDown, emergencyLed, ledBus0, ledBus1, ledBus2, ledBus3, clearPiano, countEnablePiano;
always @ (clock)
begin
	/*accende o spegne la luce di emergenza disattivando
	la salita o la discesa se si attiva lo switch
	di emergenza*/
	if(emergencySwitch == 1'b1)
	begin
		countEnable<=1'b0;
		prenotati <= 4'b0000;
		clearPiano<=1'b1;
		emergencyLed<=1'b0;
		////////////////////QUESTO CI VA???????????///////////
		clearPiano<=1'b0;
	end
	else 
	begin
		/*se quando esco dall'emergenza c'erano delle
		prenotazioni, devo far ripartire
		l'ascensore*/
		emergencyLed<=1'b1;
	end
			
	/*controllo la perssione di un bottone ed organizzo
	la prenotazione in prenotati ed accendo la luce 
	corrispondente se non prenoto
	un piano a cui sono gia', quando premo il primo
	bottone l'ascensore inizia a muoversi*/
	if(inButton0 == 1'b1 && ~(qBus >= 8'b00000000 && qBus < 8'b00100000))
	begin
		prenotati[0] <=1'b1;
		ledBus0<=1'b1;
		if((countEnablePiano != 1'b1) && (emergencySwitch != 1'b1))countEnable<=1'b1;
	end
	if(inButton1 == 1'b1 && ~(qBus >= 8'b00100000 && qBus < 8'b01000000))
	begin
		prenotati[1] <=1'b1;
		ledBus1<=1'b1;
		if((countEnablePiano != 1'b1) && (emergencySwitch != 1'b1))countEnable<=1'b1;
	end
	if(inButton2 == 1'b1 && ~(qBus >= 8'b01000000 && qBus < 8'b01100000))
	begin
		prenotati[2] <=1'b1;
		ledBus2<=1'b1;
		if((countEnablePiano != 1'b1) && (emergencySwitch != 1'b1))countEnable<=1'b1;
	end
	if(inButton3 == 1'b1 && ~(qBus >= 8'b01100000 && qBus < 8'b10000000))
	begin
		prenotati[3] <=1'b1;
		ledBus3<=1'b1;
		if((countEnablePiano != 1'b1) && (emergencySwitch != 1'b1))countEnable<=1'b1;
	end
	
	/*sto fermo al piano e riparto solo se ci sono prenotazioni
	appena e' finita l'attesa al piano al termine della quale
	resetto il tempo d'attesa*/
	if(countEnablePiano == 1'b1)
	begin
		if(pianoBus == 4'b1111)
		begin
			clearPiano<=1'b1;
			/////////////QUESTO CI VA????????????//////
			clearPiano<=1'b0;
			countEnablePiano<=1'b0;
			if(prenotati != 4'b0000)countEnable<=1'b1;
			else countEnable<=1'b0;
		end
	end
	/*oppure se mi sto muovendo*/
	else
	begin
		/*spegne il led del piano quando si raggiunge*/
		/*piano terra*/
		if((qBus >= 8'b00000000) && (qBus < 8'b00100000))
		begin
			if(prenotati[0] == 1'b1)
			begin
				/*se ci sono e volevo andarci, mi fermo al piano
				e smetto di salire e spengo la luce di prenotazione*/
				countEnablePiano<=1'b1;
				countEnable<=1'b0;
				ledBus0<=1'b0;
				/*mi tolgo dalla prenotazione*/
				prenotati[0] <= 1'b0;
			end
		end
		/*se non sono al piano prenotato, accendo la luce di prenotazione
		e aggiorno la prenotazione*/
		/*primo piano*/
		if(qBus >= 8'b00100000 && qBus < 8'b01000000)
		begin
			if(prenotati[1] == 1'b1)
			begin
				countEnablePiano<=1'b1;
				countEnable<=1'b0;
				ledBus1<=1'b0;
				prenotati[1] <= 1'b0;
			end
		end
		/*secondo piano*/
		if(qBus >= 8'b01000000 && qBus < 8'b01100000)
		begin
			if(prenotati[2] == 1'b1)
			begin
				countEnablePiano<=1'b1;
				countEnable<=1'b0;
				ledBus2<=1'b0;
				prenotati[2] <= 1'b0;
			end
		end
		/*ultimo piano*/
		if(qBus >= 8'b01100000 && qBus < 8'b10000000)
		begin
			if(prenotati[3] == 1'b1)
			begin
				countEnablePiano<=1'b1;
				countEnable<=1'b0;
				ledBus3<=1'b0;
				prenotati[3] <= 1'b0;
			end
		end
	end
	
	/*aggiorno salita o discesa solo se ci sono prenotazioni
	in base a se stavo gia' salendo o scendendo*/
	case(upDown)
	   1'b0 : 
	   /*stavo scendendo*/
	   begin
			/*piano 0*/
			if(qBus >= 8'b00000000 && qBus < 8'b00100000)
			begin
				/*se c'e' una qualche prenotazione muovo l'ascensore*/
				if(prenotati[1] == 1'b1 || prenotati[2] == 1'b1 || prenotati[3] == 1'b1)
				begin
					upDown<=1'b1;
					countEnable<=1'b1;
				end
			end
			/*piano 1*/
			if(qBus >= 8'b00100000 && qBus < 8'b01000000)
			begin
				/*se stavo scendendo e c'e' prenotato 
				il piano sotto di me, non faccio niente e continuo a scendere*/
				if(prenotati[0] == 1'b1);
				else
				begin
					/*altrimenti se non devo piu' scendere e 
					qualcuno vuole salire, salgo*/
					if(prenotati[2] == 1'b1 || prenotati[3] == 1'b1)upDown<=1'b1;
					/*se le prenotazioni sono vuote sto fermo*/
					else countEnable<=1'b0;
				end
			end
			/*piano 2*/
			if(qBus >= 8'b01000000 && qBus < 8'b01100000)
			begin
				if(prenotati[0] == 1'b1 || prenotati[1] == 1'b1);
				else
				begin
					if(prenotati[3] == 1'b1)upDown<=1'b1;
					else countEnable<=1'b0;
				end
			end
			/*piano 3*/
			if(qBus >= 8'b01100000 && qBus < 8'b10000000)
			begin
				/*ora devo per forza scendere ma non dovrei mai finire 
				in questo caso*/
				upDown<=1'b0;
			end
		end
	   1'b1 :
	   /*salgo*/
	   begin
			/*piano 0*/
			if(qBus >= 8'b00000000 && qBus < 8'b00100000)
			begin
				/*non dovrei mai finire qua*/
				upDown<=1'b1;
			end
			/*piano 1*/
			if(qBus >= 8'b00100000 && qBus < 8'b01000000)
			begin
				if(prenotati[2] == 1'b1 || prenotati[3] == 1'b1);
				else
				begin
					if(prenotati[0] == 1'b1)upDown<=1'b0;
					else countEnable<=1'b0;
				end
			end
			/*piano 2*/
			if(qBus >= 8'b01000000 && qBus < 8'b01100000)
			begin
				if(prenotati[3] == 1'b1);
				else
				begin
					if(prenotati[0] == 1'b1 || prenotati[1] == 1'b1)upDown<=1'b0;
					else countEnable<=1'b0;
				end
			end
			/*piano 3*/
			if(qBus >= 8'b01100000 && qBus < 8'b10000000)
			begin
				if(prenotati[0] == 1'b1 || prenotati[1] == 1'b1 || prenotati[2] == 1'b1)
					begin
						upDown<=1'b0;
						countEnable<=1'b1;
					end
			end
		end
	endcase
end
endmodule